package com.milosev.neverendingapplication

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.os.Build
import androidx.annotation.RequiresApi
import androidx.localbroadcastmanager.content.LocalBroadcastManager
import com.milosev.justanotherrealtimetrackingapp.IntentAction
import com.milosev.justanotherrealtimetrackingapp.IntentExtras

class MyBroadcastReceiver : BroadcastReceiver() {

    @RequiresApi(Build.VERSION_CODES.O)
    override fun onReceive(context: Context, intent: Intent) {
        when (intent.action) {
            IntentAction.START_MY_SERVICE -> {
                val myIntent = Intent(context, MainActivity::class.java).setAction(IntentAction.START_MY_SERVICE)
                LocalBroadcastManager.getInstance(context).sendBroadcast(myIntent)
            }

            IntentAction.RESTART_MY_SERVICE -> {
                val intentRestart = Intent(context, MyService::class.java)
                intentRestart.action = IntentAction.RESTART_MY_SERVICE
                context.startForegroundService(intent)
            }

            IntentAction.STOP_MY_SERVICE -> {
                val stopMyServiceIntent = Intent(
                    context,
                    MyService::class.java
                ).setAction(IntentAction.STOP_MY_SERVICE)
                context.startForegroundService(stopMyServiceIntent)
            }

            IntentAction.NUM_OF_TICKS -> {
                val mainActivityIntent = Intent(context, MainActivity::class.java).setAction(IntentAction.NUM_OF_TICKS)
                val numOfTicks = intent.getIntExtra (IntentExtras.NUM_OF_TICKS, 30)
                mainActivityIntent.putExtra(IntentExtras.NUM_OF_TICKS, numOfTicks)
                LocalBroadcastManager.getInstance(context).sendBroadcast(mainActivityIntent)
            }
        }
    }
}